require '_h2ph_pre.ph';

require 'linux/list.ph';
require 'linux/sched.ph';
require 'linux/netdevice.ph';
require 'linux/pagemap.ph';
unless(defined(&__exit)) {
    sub __exit () {	1;}
}
unless(defined(&pci_enable_device)) {
    sub pci_enable_device {
	local($x) = @_;
	eval q(0);
    }
}
unless(defined(&page_address)) {
    sub page_address {
	local($x) = @_;
	eval q(($x |  &PAGE_OFFSET));
    }
}
unless(defined(&TTY_DRIVER_NO_DEVFS)) {
    sub TTY_DRIVER_NO_DEVFS () {	0;}
}
unless(defined(&net_device)) {
    sub net_device () {	 &device;}
}
unless(defined(&dev_kfree_skb_irq)) {
    sub dev_kfree_skb_irq {
	local($a) = @_;
	eval q( &dev_kfree_skb($a));
    }
}
unless(defined(&netif_wake_queue)) {
    sub netif_wake_queue {
	local($dev) = @_;
	eval q( &do {  &clear_bit(0,  ($dev->{tbusy}));  &mark_bh( &NET_BH); }  &while(0));
    }
}
unless(defined(&netif_stop_queue)) {
    sub netif_stop_queue {
	local($dev) = @_;
	eval q( &set_bit(0,  ($dev->{tbusy})));
    }
}
unless(defined(&netif_start_queue)) {
    sub netif_start_queue {
	local($dev) = @_;
	eval q( &do {  ($dev->{tbusy}) = 0;  ($dev->{interrupt}) = 0;  ($dev->{start}) = 1; }  &while (0));
    }
}
unless(defined(&netif_queue_stopped)) {
    sub netif_queue_stopped {
	local($dev) = @_;
	eval q( ($dev->{tbusy}));
    }
}
unless(defined(&netif_running)) {
    sub netif_running {
	local($dev) = @_;
	eval q( ($dev->{start}));
    }
}
unless(defined(&NET_XMIT_SUCCESS)) {
    sub NET_XMIT_SUCCESS () {	0;}
}
unless(defined(&NET_XMIT_DROP)) {
    sub NET_XMIT_DROP () {	1;}
}
unless(defined(&NET_XMIT_CN)) {
    sub NET_XMIT_CN () {	2;}
}
unless(defined(&IORESOURCE_IO)) {
    sub IORESOURCE_IO () {	1;}
}
unless(defined(&pci_resource_start)) {
    sub pci_resource_start {
	local($dev,$bar) = @_;
	eval q(((($dev)-> $base_address[($bar)] &  &PCI_BASE_ADDRESS_SPACE) ? (($dev)-> $base_address[($bar)] &  &PCI_BASE_ADDRESS_IO_MASK) : (($dev)-> $base_address[($bar)] &  &PCI_BASE_ADDRESS_MEM_MASK)));
    }
}
unless(defined(&pci_resource_flags)) {
    sub pci_resource_flags {
	local($dev, $i) = @_;
	eval q(( ($dev->{base_address[$i]}) &  &IORESOURCE_IO));
    }
}
1;
